# Deployment - cluster/Container

Note in the cluster, first initialize Hecuba infrastructure and the compile:

module use /apps/HECUBA/modulefiles
module load Hecuba/1.0
c4s RUN --qos=debug -t=02:00:00 -nC=2 --logs=/home/bsc32/bsc32044/hecuba/logs &

This will load the python-develop package needed for gfortran to compile the forpy lib with the python flags

In the container, to launch Cassandra just execute this command:

cassandra -R

After launching, set the variables needed by Hecuba
for docker container:
export CONTACT_NAMES=127.0.0.1
export EXECUTION_NAME=docker_tests
for docker cluster:
export CONTACT_NAMES=<NodeNames>
export EXECUTION_NAME=mn4_tests

# Compilation

get the sources:
 
git clone https://earth.bsc.es/gitlab/ces/eflows4hpc-wp5.git
cd /eflows4hpc-wp5/src/poc/fortran_python
cd /lib
git clone https://github.com/ylikx/forpy.git

## set gcc version

Preferred version used in the cluster compatible with Hecuba libs:

gcc (SUSE Linux) 8.1.0
Copyright (C) 2018 Free Software Foundation, Inc.
This is free software; see the source for copying conditions.  There is NO
warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

to compile:

## for Python 3.7 and earlier
gfortran -o poc.a  forpy/forpy_mod.F90 hecuba_exporter.F90 main.F90 `python3-config --ldflags`
## for Python 3.8 and higher
gfortran -o poc.a  forpy/forpy_mod.F90 hecuba_exporter.F90 main.F90 `python3-config --ldflags --embed`

#to check if cassandra is running:
in the container:

! nodetool -h 127.0.0.1  status
! cqlsh 127.0.0.1 -e "describe keyspaces"

in the cluster:




# run the example
./a.out

# check that actually it ran correctly

Remember to put the node correctly and the keyspace (mn4_tests in this case)
! cqlsh s03r2b68-ib0 -e "select * from mn4_tests.FesomOutput_2D"

 storage_id                           | accuracy | description             | freq | freq_unit | glsize | id  | lcsize | name | units
--------------------------------------+----------+-------------------------+------+-----------+--------+-----+--------+------+-------
 e0e072f0-3412-336a-8c66-804fe178f503 |        5 | sea surface temperature |    3 |         V |      1 | 393 |      2 |  sst |     C


# Hecuba settings
Hecuba uses python/3.6.4_ML maybe better to use same versions for compiling
1) gcc/7.2.0 => gcc/8.1.0     
2) impi/2017.4 => impi/2018.1     
3) mkl/2017.4 => mkl/2018.1     
4) python/3.8.2 => python/3.6.4_ML
