module load COMPSs

# experiment configuration
# only parameter - #CORES
export FESOM_CORES=$1
export QOS=$2
export MEMBERS=$3
export FESOM_WORKINGDIR="/home/bsc32/bsc32044/fesom_hecuba/work_core2"
export FESOM_EXE="fesom.x"
export NODE_ALLOCATION=$(((${FESOM_CORES}/48)*${MEMBERS}))
echo "Number of cores: ${FESOM_CORES}"
echo "Number of nodes to be used: ${NODE_ALLOCATION}"

# Sample invocation of this script:
# ./launch_mn4.sh 144 debug 3
# $1 number of cores needed by the task
# $2 QoS to be used (determines the queue)
# $3 number of simulations of the ensemble
enqueue_compss -t  --sc_cfg=mn.cfg --qos=${QOS} --log_level=debug  --job_name=fesom2 --exec_time=20 --worker_in_master_cpus=48 --num_nodes=${NODE_ALLOCATION}  --pythonpath=$PWD  esm_simulation.py ${MEMBERS}
